import java.util.Iterator;

/**
 * FibonacciIterator starts 1, 1 every successive number is the sum of the two
 * preceeding numbers 1, 1, 2, 3, 5, 8, ...
 */
public class FibonacciIterator implements Iterator<Integer> {
    private int length;
    private int current;
    private int next;

    public FibonacciIterator(int n) {
        length = n;
        current = 1;
        next = 1;
    }


    @Override
    public boolean hasNext() {
        return length >= 0;
    }

    @Override
    public Integer next() {
        int temp = current;
        current = next;
        next = current + temp;
        length--;
        return temp;
    }

    public static void main(String[] args) {
        FibonacciIterator iter = new FibonacciIterator(15);
        while (iter.hasNext()) {
            System.out.println(iter.next());
        }
    }
}